Gecode::Action::Recorder< View > Class Template Reference

Propagator for recording action information. More...

`#include <action.hpp>`

## Classes

class | Idx
| Advisor with index and change information. More...

## Public Member Functions

| Recorder (Home home, ViewArray< View > &x, Action &a)
| Constructor for creation.
virtual Propagator * | copy (Space &home)
| Copy propagator during cloning.
virtual PropCost | cost (const Space &home, const ModEventDelta &med) const
| Cost function (record so that propagator runs last).
virtual void | reschedule (Space &home)
| Schedule function.
virtual ExecStatus | advise (Space &home, Advisor &a, const Delta &d)
| Give advice to propagator.
virtual void | advise (Space &home, Advisor &a)
| Give advice to propagator when home has failed.
virtual ExecStatus | propagate (Space &home, const ModEventDelta &med)
| Perform propagation.
virtual size_t | dispose (Space &home)
| Delete propagator and return its size.
ModEventDelta | modeventdelta (void) const
| Return the modification event delta.
double | afc (void) const
| Return the accumlated failure count.
unsigned int | id (void) const
| Return propagator id.
PropagatorGroup | group (void) const
| Return group propagator belongs to.
void | group (PropagatorGroup g)
| Add propagator to group g.
bool | disabled (void) const
| Whether propagator is currently disabled.
virtual | ~Actor (void)
| To avoid warnings.

## Static Public Member Functions

static ExecStatus | post (Home home, ViewArray< View > &x, Action &a)
| Post action recorder propagator.
static void * | operator new (size_t s, Space &home)
| Allocate memory from space.
static void | operator delete (void *p, Space &home)
| No-op for exceptions.
static void * | operator new (size_t s)
| Not used.
static void | operator delete (void *p)
| Not used.

## Protected Member Functions

| Recorder (Space &home, Recorder< View > &p)
| Constructor for cloning p.
Protected Member Functions inherited from Gecode::NaryPropagator< View, PC_GEN_NONE >
| NaryPropagator (Space &home, NaryPropagator &p)
| Constructor for cloning p.
Protected Member Functions inherited from Gecode::Propagator
| Propagator (Home home)
| Constructor for posting.
| Propagator (Space &home, Propagator &p)
| Constructor for cloning p.
Propagator * | fwd (void) const
| Return forwarding pointer during copying.
Kernel::GPI::Info & | gpi (void)
| Provide access to global propagator information.

## Protected Attributes

Action | a
| Access to action information.
Council< Idx > | c
| The advisor council.
Protected Attributes inherited from Gecode::NaryPropagator< View, PC_GEN_NONE >
ViewArray< View > | x
| Array of views.

## Detailed Description

template<class View>
class Gecode::Action::Recorder< View >

Propagator for recording action information.

Definition at line 131 of file action.hpp.

## Constructor & Destructor Documentation

## Recorder() [1/2]

template<class View>

Gecode::Action::Recorder< View >::Recorder | ( | Space & | home,
|  | Recorder< View > & | p )

inline protected

Constructor for cloning p.

Definition at line 365 of file action.hpp.

## Recorder() [2/2]

template<class View>

Gecode::Action::Recorder< View >::Recorder | ( | Home | home,
|  | ViewArray< View > & | x,
|  | Action & | a )

inline

Constructor for creation.

Definition at line 233 of file action.hpp.

## Member Function Documentation

## copy()

template<class View>

Propagator * Gecode::Action::Recorder< View >::copy | ( | Space & | home | ) |

virtual

Copy propagator during cloning.

Implements Gecode::Actor.

Definition at line 372 of file action.hpp.

## cost()

template<class View>

PropCost Gecode::Action::Recorder< View >::cost | ( | const Space & | home,
|  | const ModEventDelta & | med ) const

virtual

Cost function (record so that propagator runs last).

Reimplemented from Gecode::NaryPropagator< View, PC_GEN_NONE >.

Definition at line 392 of file action.hpp.

## reschedule()

template<class View>

void Gecode::Action::Recorder< View >::reschedule | ( | Space & | home | ) |

virtual

Schedule function.

Reimplemented from Gecode::NaryPropagator< View, PC_GEN_NONE >.

Definition at line 398 of file action.hpp.

## advise() [1/2]

template<class View>

ExecStatus Gecode::Action::Recorder< View >::advise | ( | Space & | home,
|  | Advisor & | a,
|  | const Delta & | d )

virtual

Give advice to propagator.

Reimplemented from Gecode::Propagator.

Definition at line 404 of file action.hpp.

## advise() [2/2]

template<class View>

void Gecode::Action::Recorder< View >::advise | ( | Space & | home,
|  | Advisor & | a )

virtual

Give advice to propagator when home has failed.

Reimplemented from Gecode::Propagator.

Definition at line 411 of file action.hpp.

## propagate()

template<class View>

ExecStatus Gecode::Action::Recorder< View >::propagate | ( | Space & | home,
|  | const ModEventDelta & | med )

virtual

Perform propagation.

Implements Gecode::Propagator.

Definition at line 417 of file action.hpp.

## dispose()

template<class View>

size_t Gecode::Action::Recorder< View >::dispose | ( | Space & | home | ) |

inline virtual

Delete propagator and return its size.

Reimplemented from Gecode::NaryPropagator< View, PC_GEN_NONE >.

Definition at line 378 of file action.hpp.

## post()

template<class View>

ExecStatus Gecode::Action::Recorder< View >::post | ( | Home | home,
|  | ViewArray< View > & | x,
|  | Action & | a )

inline static

Post action recorder propagator.

Definition at line 244 of file action.hpp.

## Member Data Documentation

## a

template<class View>

Action Gecode::Action::Recorder< View >::a

protected

Access to action information.

Definition at line 154 of file action.hpp.

## c

template<class View>

Council<Idx> Gecode::Action::Recorder< View >::c

protected

The advisor council.

Definition at line 156 of file action.hpp.

The documentation for this class was generated from the following file:

- gecode/kernel/branch/action.hpp